/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -k1,3,$ -t -p -T -C -N keyword_lookup -g keywords.in  */
/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://sed.free.fr/gtkcooker
 * Public domain.
 */
#include "keywords.h"

#include <string.h>


#define TOTAL_KEYWORDS 88
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 22
#define MIN_HASH_VALUE 6
#define MAX_HASH_VALUE 279
/* maximum key range = 274, duplicates = 0 */

#ifdef __GNUC__
inline
#endif
static unsigned int
hash (str, len)
     register unsigned char *str;
     register int unsigned len;
{
  static const unsigned short asso_values[] =
    {
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280, 280, 280, 280,
     280, 280, 280, 280, 280, 280, 280,  50,  25, 125,
      60,   0,   0,   2,  40,  70, 280,  30,  10, 100,
     120,  75,   0, 280,   0,  35,  95,  30,   5,  40,
       5,  15, 280, 280, 280, 280, 280, 280,
    };
  register int hval = len;

  switch (hval)
    {
      default:
      case 3:
        hval += asso_values[str[2]];
      case 2:
      case 1:
        hval += asso_values[str[0]];
        break;
    }
  return hval + asso_values[str[len - 1]];
}

#ifdef __GNUC__
inline
#endif
const struct keywords *
keyword_lookup (str, len)
     register unsigned char *str;
     register unsigned int len;
{
  static const struct keywords wordlist[] =
    {
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"expose",  KEYWORD_EXPOSE},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"file",  KEYWORD_FILE},
      {"false",  KEYWORD_FALSE},
      {"",}, 
      {"foreground_active",  KEYWORD_FOREGROUND_ACTIVE},
      {"",}, {"",}, {"",}, {"",}, 
      {"foreground_insensitive",  KEYWORD_FOREGROUND_INSENSITIVE},
      {"vertical",  KEYWORD_VERTICAL},
      {"fill",  KEYWORD_FILL},
      {"",}, {"",}, 
      {"foreground_normal",  KEYWORD_FOREGROUND_NORMAL},
      {"",}, {"",}, {"",}, 
      {"border",  KEYWORD_BORDER},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"box",  KEYWORD_BOX},
      {"",}, {"",}, {"",}, 
      {"resizer",  KEYWORD_RESIZER},
      {"",}, 
      {"separator",  KEYWORD_SEPARATOR},
      {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"label",  KEYWORD_LABEL},
      {"scroll",  KEYWORD_SCROLL},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"horizontal",  KEYWORD_HORIZONTAL},
      {"",}, {"",}, 
      {"key",  KEYWORD_KEY},
      {"",}, 
      {"leave",  KEYWORD_LEAVE},
      {"expand",  KEYWORD_EXPAND},
      {"",}, {"",}, 
      {"padding",  KEYWORD_PADDING},
      {"foreground",  KEYWORD_FOREGROUND},
      {"source",  KEYWORD_SOURCE},
      {"",}, {"",}, {"",}, {"",}, 
      {"delete",  KEYWORD_DELETE,},
      {"pointer",  KEYWORD_POINTER},
      {"",}, 
      {"foreground_selected",  KEYWORD_FOREGROUND_SELECTED},
      {"",}, {"",}, 
      {"group",  KEYWORD_GROUP},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"",}, 
      {"global",  KEYWORD_GLOBAL},
      {"spacing",  KEYWORD_SPACING},
      {"",}, {"",}, {"",}, 
      {"top",  KEYWORD_TOP},
      {"type",  KEYWORD_TYPE},
      {"enter",  KEYWORD_ENTER},
      {"",}, 
      {"right",  KEYWORD_RIGHT},
      {"toggle",  KEYWORD_TOGGLE},
      {"",}, {"",}, {"",}, 
      {"ok",  KEYWORD_OK},
      {"",}, 
      {"left",  KEYWORD_LEFT},
      {"",}, {"",}, {"",}, {"",}, 
      {"foreground_prelight",  KEYWORD_FOREGROUND_PRELIGHT},
      {"entry",  KEYWORD_ENTRY},
      {"",}, {"",}, {"",}, {"",}, 
      {"hcode",  KEYWORD_HCODE},
      {"grow",  KEYWORD_GROW},
      {"",}, {"",}, {"",}, 
      {"image",  KEYWORD_IMAGE},
      {"",}, {"",}, {"",}, 
      {"true",  KEYWORD_TRUE},
      {"never",  KEYWORD_NEVER},
      {"always",  KEYWORD_ALWAYS},
      {"",}, {"",}, {"",}, 
      {"mouse",  KEYWORD_MOUSE},
      {"normal",  KEYWORD_NORMAL},
      {"",}, {"",}, {"",}, 
      {"radio",  KEYWORD_RADIO},
      {"valign",  KEYWORD_VALIGN},
      {"",}, {"",}, 
      {"list",  KEYWORD_LIST},
      {"width",  KEYWORD_WIDTH},
      {"",}, 
      {"vscroll",  KEYWORD_VSCROLL},
      {"",}, {"",}, {"",}, 
      {"active",  KEYWORD_ACTIVE},
      {"",}, 
      {"activate",  KEYWORD_ACTIVATE},
      {"draw",  KEYWORD_DRAW},
      {"multilines",  KEYWORD_MULTILINES},
      {"",}, {"",}, {"",}, {"",}, 
      {"check",  KEYWORD_CHECK},
      {"",}, 
      {"default",  KEYWORD_DEFAULT},
      {"position",  KEYWORD_POSITION},
      {"",}, 
      {"focus",  KEYWORD_FOCUS},
      {"",}, 
      {"background_active",  KEYWORD_BACKGROUND_ACTIVE},
      {"hinclude",  KEYWORD_HINCLUDE},
      {"",}, {"",}, {"",}, 
      {"background_insensitive",  KEYWORD_BACKGROUND_INSENSITIVE},
      {"",}, {"",}, 
      {"modal",  KEYWORD_MODAL},
      {"halign",  KEYWORD_HALIGN},
      {"background_normal",  KEYWORD_BACKGROUND_NORMAL},
      {"",}, {"",}, {"",}, {"",}, 
      {"hscroll",  KEYWORD_HSCROLL},
      {"dad",  KEYWORD_DAD},
      {"",}, {"",}, 
      {"homogeneous",  KEYWORD_HOMOGENEOUS},
      {"",}, {"",}, 
      {"direction",  KEYWORD_DIRECTION},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"text",  KEYWORD_TEXT},
      {"",}, 
      {"widget",  KEYWORD_WIDGET},
      {"include",  KEYWORD_INCLUDE},
      {"",}, {"",}, 
      {"ccode",  KEYWORD_CCODE},
      {"window",  KEYWORD_WINDOW},
      {"",}, {"",}, {"",}, {"",}, 
      {"height",  KEYWORD_HEIGHT},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"font",  KEYWORD_FONT},
      {"background",  KEYWORD_BACKGROUND},
      {"memory",  KEYWORD_MEMORY},
      {"",}, {"",}, {"",}, {"",}, 
      {"bottom",  KEYWORD_BOTTOM},
      {"",}, {"",}, 
      {"background_selected",  KEYWORD_BACKGROUND_SELECTED},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"init",  KEYWORD_INIT},
      {"",}, {"",}, {"",}, {"",}, 
      {"none",  KEYWORD_NONE},
      {"",}, 
      {"button",  KEYWORD_BUTTON},
      {"",}, {"",}, {"",}, {"",}, 
      {"center",  KEYWORD_CENTER},
      {"",}, 
      {"cinclude",  KEYWORD_CINCLUDE},
      {"menu",  KEYWORD_MENU},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"cancel",  KEYWORD_CANCEL},
      {"clicked",  KEYWORD_CLICKED},
      {"",}, 
      {"background_prelight",  KEYWORD_BACKGROUND_PRELIGHT},
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"automatic",  KEYWORD_AUTOMATIC},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register const char *s = wordlist[key].name;

          if (*(unsigned char *)s == *str && !strcmp ((char *)str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}

keyword lookup(char *s, int len)
{
  const struct keywords *ret = keyword_lookup(s, len);
  if (!ret) return NULL_KEYWORD;
  return ret->key;
}

static char *key[] = {
  "NULL",			/* NULL_KEYWORD */
  "activate",			/* KEYWORD_ACTIVATE */
  "active",			/* KEYWORD_ACTIVE */
  "always",			/* KEYWORD_ALWAYS */
  "automatic",			/* KEYWORD_AUTOMATIC */
  "background",			/* KEYWORD_BACKGROUND */
  "background_active",		/* KEYWORD_BACKGROUND_ACTIVE */
  "background_insensitive",	/* KEYWORD_BACKGROUND_INSENSITIVE */
  "background_normal",		/* KEYWORD_BACKGROUND_NORMAL */
  "background_prelight",	/* KEYWORD_BACKGROUND_PRELIGHT */
  "background_selected",	/* KEYWORD_BACKGROUND_SELECTED */
  "border",			/* KEYWORD_BORDER */
  "bottom",			/* KEYWORD_BOTTOM */
  "box",			/* KEYWORD_BOX */
  "button",			/* KEYWORD_BUTTON */
  "cancel",			/* KEYWORD_CANCEL */
  "ccode",			/* KEYWORD_CCODE */
  "center",			/* KEYWORD_CENTER */
  "check",			/* KEYWORD_CHECK */
  "cinclude",			/* KEYWORD_CINCLUDE */
  "clicked",			/* KEYWORD_CLICKED */
  "dad",			/* KEYWORD_DAD */
  "default",			/* KEYWORD_DEFAULT */
  "delete",			/* KEYWORD_DELETE */
  "direction",			/* KEYWORD_DIRECTION */
  "draw",			/* KEYWORD_DRAW */
  "enter",			/* KEYWORD_ENTER */
  "entry",			/* KEYWORD_ENTRY */
  "expand",			/* KEYWORD_EXPAND */
  "expose",			/* KEYWORD_EXPOSE */
  "false",			/* KEYWORD_FALSE */
  "file",			/* KEYWORD_FILE */
  "fill",			/* KEYWORD_FILL */
  "focus",			/* KEYWORD_FOCUS */
  "font",			/* KEYWORD_FONT */
  "foreground",			/* KEYWORD_FOREGROUND */
  "foreground_active",		/* KEYWORD_FOREGROUND_ACTIVE */
  "foreground_insensitive",	/* KEYWORD_FOREGROUND_INSENSITIVE */
  "foreground_normal",		/* KEYWORD_FOREGROUND_NORMAL */
  "foreground_prelight",	/* KEYWORD_FOREGROUND_PRELIGHT */
  "foreground_selected",	/* KEYWORD_FOREGROUND_SELECTED */
  "global",			/* KEYWORD_GLOBAL */
  "group",			/* KEYWORD_GROUP */
  "grow",			/* KEYWORD_GROW */
  "halign",			/* KEYWORD_HALIGN */
  "hcode",			/* KEYWORD_HCODE */
  "height",			/* KEYWORD_HEIGHT */
  "hinclude",			/* KEYWORD_HINCLUDE */
  "homogeneous",		/* KEYWORD_HOMOGENEOUS */
  "horizontal",			/* KEYWORD_HORIZONTAL */
  "hscroll",			/* KEYWORD_HSCROLL */
  "image",			/* KEYWORD_IMAGE */
  "include",			/* KEYWORD_INCLUDE */
  "init",			/* KEYWORD_INIT */
  "key",			/* KEYWORD_KEY */
  "label",			/* KEYWORD_LABEL */
  "leave",			/* KEYWORD_LEAVE */
  "left",			/* KEYWORD_LEFT */
  "list",			/* KEYWORD_LIST */
  "memory",			/* KEYWORD_MEMORY */
  "menu",			/* KEYWORD_MENU */
  "modal",			/* KEYWORD_MODAL */
  "mouse",			/* KEYWORD_MOUSE */
  "multilines",			/* KEYWORD_MULTILINES */
  "never",			/* KEYWORD_NEVER */
  "none",			/* KEYWORD_NONE */
  "normal",			/* KEYWORD_NORMAL */
  "ok",				/* KEYWORD_OK */
  "padding",			/* KEYWORD_PADDING */
  "pointer",			/* KEYWORD_POINTER */
  "position",			/* KEYWORD_POSITION */
  "radio",			/* KEYWORD_RADIO */
  "resizer",			/* KEYWORD_RESIZER */
  "right",			/* KEYWORD_RIGHT */
  "scroll",			/* KEYWORD_SCROLL */
  "separator",			/* KEYWORD_SEPARATOR */
  "source",			/* KEYWORD_SOURCE */
  "spacing",			/* KEYWORD_SPACING */
  "text",			/* KEYWORD_TEXT */
  "toggle",			/* KEYWORD_TOGGLE */
  "top",			/* KEYWORD_TOP */
  "true",			/* KEYWORD_TRUE */
  "type",			/* KEYWORD_TYPE */
  "valign",			/* KEYWORD_VALIGN */
  "vertical",			/* KEYWORD_VERTICAL */
  "vscroll",			/* KEYWORD_VSCROLL */
  "widget",			/* KEYWORD_WIDGET */
  "width",			/* KEYWORD_WIDTH */
  "window",			/* KEYWORD_WINDOW */
};

char *get_keyword(keyword x)
{
  return key[x];
}
